searchNodes=[{"doc":"Haystack is a simple, extendable search engine written in Elixir. Installation Haystack can be installed by adding haystack to your list of dependencies in mix.exs : def deps do [ { :haystack , &quot;~&gt; 0.1.0&quot; } ] end The entry point to Haystack is the Haystack module. This module is responsible for managing the various indexes you have as part of the project as well as any future configuration or high level concerns. These conserns are encapsulated in the %Haystack{} struct: haystack = Haystack . new ( ) Currently, the Haystack module has a single index/3 function that accepts the name of the index as an atom and a callback function to apply changes to the index. If the index does not already exist, Haystack will create one and pass it into the callback so you can configure or use it: Haystack . index ( haystack , :animals , fn index -&gt; index end ) Once you have an index , the first thing you need to do is apply specify the fields of the index: alias Haystack.Index Haystack . index ( haystack , :animals , fn index -&gt; index |&gt; Index . ref ( Index.Field . term ( &quot;id&quot; ) ) |&gt; Index . field ( Index.Field . new ( &quot;name&quot; ) ) |&gt; Index . field ( Index.Field . new ( &quot;description&quot; ) ) end ) The ref is the identifier of the document. You can create as many fields on the document as you want. When you add documents to the index, Haystack will automatically extract the fields you have configured. You can also provide nested fields using dot syntax: alias Haystack.Index Haystack . index ( haystack , :people , fn index -&gt; index |&gt; Index . ref ( Index.Field . term ( &quot;id&quot; ) ) |&gt; Index . field ( Index.Field . new ( &quot;name&quot; ) ) |&gt; Index . field ( Index.Field . new ( &quot;address.postcode&quot; ) ) end ) Each Haystack index has a configurable storage implementation. By default the storage implementation is essentially a map, which is great for testing and prototyping, but probably not a good solution if you want to use Haystack as part of a real application. You can configure a custom storage implementation on the index: alias Haystack . { Index , Storage } Haystack . index ( haystack , :animals , fn index -&gt; index |&gt; Index . ref ( Index.Field . term ( &quot;id&quot; ) ) |&gt; Index . field ( Index.Field . new ( &quot;name&quot; ) ) |&gt; Index . field ( Index.Field . new ( &quot;description&quot; ) ) |&gt; Index . storage ( Storage.ETS . new ( ) ) end ) The ETS storage implementation is provided as one of the default implementations that ships with Haystack out of the box. If you would like to extend Haystack with your own storage implementation, it's very easy to do so. We'll look at doing that later in this blog post. Finally, the most important part of a library that provides full-text search is the ability to query the indexes. Here is the most basic version of applying queries: Haystack . index ( haystack , :animals , &amp; Index . search ( &amp;1 , &quot;Red Panda&quot; ) ) This would search the :animals index for the phrase &quot;Red Panda&quot; . Haystack also offers a powerful way to build and run search queries, which we'll look at later in this blog post.","ref":"Haystack.html","title":"Haystack","type":"module"},{"doc":"Interact with the given index. Examples iex&gt; haystack = Haystack . new ( ) iex&gt; Haystack . index ( haystack , :animals , &amp; Function . identity / 1 )","ref":"Haystack.html#index/3","title":"Haystack.index/3","type":"function"},{"doc":"Create a new Haystack. Examples iex&gt; Haystack . new ( )","ref":"Haystack.html#new/1","title":"Haystack.new/1","type":"function"},{"doc":"","ref":"Haystack.html#t:t/0","title":"Haystack.t/0","type":"type"},{"doc":"A module for managing indexes. The index is used to manage configuration and acts as a central point to add, update, delete, or query the storage.","ref":"Haystack.Index.html","title":"Haystack.Index","type":"module"},{"doc":"Add documents to the index. Examples iex&gt; index = Index . new ( :animals ) iex&gt; Index . add ( index , [ ] )","ref":"Haystack.Index.html#add/2","title":"Haystack.Index.add/2","type":"function"},{"doc":"Set the attrs of the index. Examples iex&gt; index = Index . new ( :animals ) iex&gt; Index . attrs ( index , %{ insert : [ Global ] , delete : [ Global ] } )","ref":"Haystack.Index.html#attrs/2","title":"Haystack.Index.attrs/2","type":"function"},{"doc":"Delete documents in the index. Examples iex&gt; index = Index . new ( :animals ) iex&gt; Index . delete ( index , [ ] )","ref":"Haystack.Index.html#delete/2","title":"Haystack.Index.delete/2","type":"function"},{"doc":"Add a field to the index. Examples iex&gt; index = Index . new ( :animals ) iex&gt; Index . field ( index , Index.Field . new ( &quot;name&quot; ) )","ref":"Haystack.Index.html#field/2","title":"Haystack.Index.field/2","type":"function"},{"doc":"Create a new index. Examples iex&gt; Index . new ( :animals )","ref":"Haystack.Index.html#new/2","title":"Haystack.Index.new/2","type":"function"},{"doc":"Add a ref to the index. Examples iex&gt; index = Index . new ( :animals ) iex&gt; Index . ref ( index , Index.Field . new ( &quot;id&quot; ) )","ref":"Haystack.Index.html#ref/2","title":"Haystack.Index.ref/2","type":"function"},{"doc":"Search the index.","ref":"Haystack.Index.html#search/3","title":"Haystack.Index.search/3","type":"function"},{"doc":"Set the storage on the index. Examples iex&gt; index = Index . new ( :animals ) iex&gt; Index . storage ( index , Storage.Map . new ( ) )","ref":"Haystack.Index.html#storage/2","title":"Haystack.Index.storage/2","type":"function"},{"doc":"","ref":"Haystack.Index.html#t:attrs/0","title":"Haystack.Index.attrs/0","type":"type"},{"doc":"","ref":"Haystack.Index.html#t:fields/0","title":"Haystack.Index.fields/0","type":"type"},{"doc":"","ref":"Haystack.Index.html#t:opts/0","title":"Haystack.Index.opts/0","type":"type"},{"doc":"","ref":"Haystack.Index.html#t:t/0","title":"Haystack.Index.t/0","type":"type"},{"doc":"A behaviour for defining a store attr.","ref":"Haystack.Index.Attr.html","title":"Haystack.Index.Attr","type":"behaviour"},{"doc":"Return the default attrs.","ref":"Haystack.Index.Attr.html#default/0","title":"Haystack.Index.Attr.default/0","type":"function"},{"doc":"Delete an attr.","ref":"Haystack.Index.Attr.html#c:delete/3","title":"Haystack.Index.Attr.delete/3","type":"callback"},{"doc":"Insert an attr.","ref":"Haystack.Index.Attr.html#c:insert/3","title":"Haystack.Index.Attr.insert/3","type":"callback"},{"doc":"The attr key.","ref":"Haystack.Index.Attr.html#c:key/1","title":"Haystack.Index.Attr.key/1","type":"callback"},{"doc":"","ref":"Haystack.Index.Attr.html#t:opts/0","title":"Haystack.Index.Attr.opts/0","type":"type"},{"doc":"A module for returning a list of docs for a given field, term.","ref":"Haystack.Index.Attr.Docs.html","title":"Haystack.Index.Attr.Docs","type":"module"},{"doc":"","ref":"Haystack.Index.Attr.Docs.html#docs/1","title":"Haystack.Index.Attr.Docs.docs/1","type":"macro"},{"doc":"","ref":"Haystack.Index.Attr.Docs.html#docs/2","title":"Haystack.Index.Attr.Docs.docs/2","type":"macro"},{"doc":"A module for storing the global list of refs.","ref":"Haystack.Index.Attr.Global.html","title":"Haystack.Index.Attr.Global","type":"module"},{"doc":"","ref":"Haystack.Index.Attr.Global.html#global/1","title":"Haystack.Index.Attr.Global.global/1","type":"macro"},{"doc":"","ref":"Haystack.Index.Attr.Global.html#global/2","title":"Haystack.Index.Attr.Global.global/2","type":"macro"},{"doc":"A module for storing the meta for a field, term.","ref":"Haystack.Index.Attr.Meta.html","title":"Haystack.Index.Attr.Meta","type":"module"},{"doc":"","ref":"Haystack.Index.Attr.Meta.html#meta/1","title":"Haystack.Index.Attr.Meta.meta/1","type":"macro"},{"doc":"","ref":"Haystack.Index.Attr.Meta.html#meta/2","title":"Haystack.Index.Attr.Meta.meta/2","type":"macro"},{"doc":"A module for preparing documents to be stored.","ref":"Haystack.Index.Document.html","title":"Haystack.Index.Document","type":"module"},{"doc":"Create a new document.","ref":"Haystack.Index.Document.html#new/2","title":"Haystack.Index.Document.new/2","type":"function"},{"doc":"","ref":"Haystack.Index.Document.html#tokenize/1","title":"Haystack.Index.Document.tokenize/1","type":"function"},{"doc":"","ref":"Haystack.Index.Document.html#transform/1","title":"Haystack.Index.Document.transform/1","type":"function"},{"doc":"","ref":"Haystack.Index.Document.html#t:t/0","title":"Haystack.Index.Document.t/0","type":"type"},{"doc":"A module for index fields. This module allows you to configure the fields of the index. Each field can have a customised set of transformers and a custom regex used for tokenizing.","ref":"Haystack.Index.Field.html","title":"Haystack.Index.Field","type":"module"},{"doc":"Create a new field. You can include nested fields using dot syntax. The field accepts an optional list of transformers to be used as well as a regex used for tokenizing. Examples iex&gt; field = Index.Field . new ( &quot;name&quot; ) iex&gt; field . k &quot;name&quot; iex&gt; field = Index.Field . new ( &quot;address.line_1&quot; ) iex&gt; field . path [ &quot;address&quot; , &quot;line_1&quot; ]","ref":"Haystack.Index.Field.html#new/2","title":"Haystack.Index.Field.new/2","type":"function"},{"doc":"Create a new &quot;term&quot; field. A term field is a field that shouldn't be tokenized or transformed. For example, an ID, serial code, etc. Examples iex&gt; field = Index.Field . term ( &quot;id&quot; ) iex&gt; field . transformers [ ]","ref":"Haystack.Index.Field.html#term/1","title":"Haystack.Index.Field.term/1","type":"function"},{"doc":"","ref":"Haystack.Index.Field.html#t:k/0","title":"Haystack.Index.Field.k/0","type":"type"},{"doc":"","ref":"Haystack.Index.Field.html#t:t/0","title":"Haystack.Index.Field.t/0","type":"type"},{"doc":"A module for building queries.","ref":"Haystack.Query.html","title":"Haystack.Query","type":"module"},{"doc":"Build a clause for the given list of tokens. Examples iex&gt; index = Index . new ( :animals ) iex&gt; index = Index . field ( index , Index.Field . new ( &quot;name&quot; ) ) iex&gt; tokens = Tokenizer . tokenize ( &quot;Red Panda&quot; ) iex&gt; tokens = Transformer . pipeline ( tokens , Transformer . default ( ) ) iex&gt; Query . build ( :match_all , index , tokens )","ref":"Haystack.Query.html#build/3","title":"Haystack.Query.build/3","type":"function"},{"doc":"Add a clause to the query.","ref":"Haystack.Query.html#clause/2","title":"Haystack.Query.clause/2","type":"function"},{"doc":"Evaluate an expression.","ref":"Haystack.Query.html#evaluate/3","title":"Haystack.Query.evaluate/3","type":"function"},{"doc":"Evaluate a clause.","ref":"Haystack.Query.html#evaluate/4","title":"Haystack.Query.evaluate/4","type":"function"},{"doc":"Create a new Query.","ref":"Haystack.Query.html#new/1","title":"Haystack.Query.new/1","type":"function"},{"doc":"Run the given query.","ref":"Haystack.Query.html#run/2","title":"Haystack.Query.run/2","type":"function"},{"doc":"","ref":"Haystack.Query.html#t:statement/0","title":"Haystack.Query.statement/0","type":"type"},{"doc":"","ref":"Haystack.Query.html#t:t/0","title":"Haystack.Query.t/0","type":"type"},{"doc":"A module for defining query clauses.","ref":"Haystack.Query.Clause.html","title":"Haystack.Query.Clause","type":"behaviour"},{"doc":"Build the clause into a statement. Examples iex&gt; clause = Query.Clause . new ( :any ) iex&gt; Query.Clause . build ( clause )","ref":"Haystack.Query.Clause.html#build/1","title":"Haystack.Query.Clause.build/1","type":"function"},{"doc":"Add a list of clauses. Examples iex&gt; clause = Query.Clause . new ( :any ) iex&gt; Query.Clause . clauses ( clause , [ Query.Clause . new ( :any ) ] )","ref":"Haystack.Query.Clause.html#clauses/2","title":"Haystack.Query.Clause.clauses/2","type":"function"},{"doc":"Return the default clauses. Examples iex&gt; Query.Clause . default ( )","ref":"Haystack.Query.Clause.html#default/0","title":"Haystack.Query.Clause.default/0","type":"function"},{"doc":"Evaluate the given clause.","ref":"Haystack.Query.Clause.html#c:evaluate/3","title":"Haystack.Query.Clause.evaluate/3","type":"callback"},{"doc":"Add a list of expressions. Examples iex&gt; clause = Query.Clause . new ( :any ) iex&gt; expression = Query.Expression . new ( :match , field : &quot;name&quot; , term : &quot;Haystack&quot; ) iex&gt; Query.Clause . expressions ( clause , [ expression ] )","ref":"Haystack.Query.Clause.html#expressions/2","title":"Haystack.Query.Clause.expressions/2","type":"function"},{"doc":"Create a new clause. Examples iex&gt; Query.Clause . new ( :any )","ref":"Haystack.Query.Clause.html#new/1","title":"Haystack.Query.Clause.new/1","type":"function"},{"doc":"","ref":"Haystack.Query.Clause.html#t:k/0","title":"Haystack.Query.Clause.k/0","type":"type"},{"doc":"","ref":"Haystack.Query.Clause.html#t:t/0","title":"Haystack.Query.Clause.t/0","type":"type"},{"doc":"A module to define &quot;all&quot; clauses.","ref":"Haystack.Query.Clause.All.html","title":"Haystack.Query.Clause.All","type":"module"},{"doc":"A module to define &quot;any&quot; clauses.","ref":"Haystack.Query.Clause.Any.html","title":"Haystack.Query.Clause.Any","type":"module"},{"doc":"A module for defining query expressions.","ref":"Haystack.Query.Expression.html","title":"Haystack.Query.Expression","type":"behaviour"},{"doc":"Build the expression into a statement. Examples iex&gt; expression = Query.Expression . new ( :match , field : &quot;name&quot; , term : &quot;Haystack&quot; ) iex&gt; Query.Expression . build ( expression )","ref":"Haystack.Query.Expression.html#build/1","title":"Haystack.Query.Expression.build/1","type":"function"},{"doc":"Return the default expressions. Examples iex&gt; Query.Expression . default ( )","ref":"Haystack.Query.Expression.html#default/0","title":"Haystack.Query.Expression.default/0","type":"function"},{"doc":"Evaluate the given clause.","ref":"Haystack.Query.Expression.html#c:evaluate/2","title":"Haystack.Query.Expression.evaluate/2","type":"callback"},{"doc":"Create a new expression. Examples iex&gt; Query.Expression . new ( :match , field : &quot;name&quot; , term : &quot;Haystack&quot; )","ref":"Haystack.Query.Expression.html#new/2","title":"Haystack.Query.Expression.new/2","type":"function"},{"doc":"","ref":"Haystack.Query.Expression.html#t:k/0","title":"Haystack.Query.Expression.k/0","type":"type"},{"doc":"","ref":"Haystack.Query.Expression.html#t:t/0","title":"Haystack.Query.Expression.t/0","type":"type"},{"doc":"A module to define &quot;match&quot; expressions.","ref":"Haystack.Query.Expression.Match.html","title":"Haystack.Query.Expression.Match","type":"module"},{"doc":"Calculate the IDF for the results.","ref":"Haystack.Query.IDF.html","title":"Haystack.Query.IDF","type":"module"},{"doc":"Calculate the IDF for each result.","ref":"Haystack.Query.IDF.html#calculate/2","title":"Haystack.Query.IDF.calculate/2","type":"function"},{"doc":"A module and behaviour for storing data. This module acts as a convenient way to delegate to the storage implementation within Haystack. This has been created as a behaviour to make it easy to provide your own storage implementation. By default Haystack provides a memory storage implementation, which uses a map to store data.","ref":"Haystack.Storage.html","title":"Haystack.Storage","type":"behaviour"},{"doc":"Return the count of items in storage. Examples iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage . insert ( storage , :name , &quot;Haystack&quot; ) iex&gt; Storage . count ( storage ) 1","ref":"Haystack.Storage.html#count/1","title":"Haystack.Storage.count/1","type":"function"},{"doc":"Return the count of items in storage.","ref":"Haystack.Storage.html#c:count/1","title":"Haystack.Storage.count/1","type":"callback"},{"doc":"Delete an item from storage. Examples iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage . delete ( storage , :name ) iex&gt; Storage . fetch ( storage , :name ) { :error , % Storage.NotFoundError { message : &quot;Not found&quot; } } iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage . insert ( storage , :name , &quot;Haystack&quot; ) iex&gt; storage = Storage . delete ( storage , :name ) iex&gt; Storage . fetch ( storage , :name ) { :error , % Storage.NotFoundError { message : &quot;Not found&quot; } }","ref":"Haystack.Storage.html#delete/2","title":"Haystack.Storage.delete/2","type":"function"},{"doc":"Delete an item from storage.","ref":"Haystack.Storage.html#c:delete/2","title":"Haystack.Storage.delete/2","type":"callback"},{"doc":"Deserialize the storage. Examples iex&gt; binary = Storage . serialize ( Storage.Map . new ( ) ) iex&gt; Storage . deserialize ( binary )","ref":"Haystack.Storage.html#deserialize/1","title":"Haystack.Storage.deserialize/1","type":"function"},{"doc":"Fetch an item from storage. Examples iex&gt; storage = Storage.Map . new ( ) iex&gt; Storage . fetch ( storage , :name ) { :error , % Storage.NotFoundError { message : &quot;Not found&quot; } } iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage . insert ( storage , :name , &quot;Haystack&quot; ) iex&gt; Storage . fetch ( storage , :name ) { :ok , &quot;Haystack&quot; }","ref":"Haystack.Storage.html#fetch/2","title":"Haystack.Storage.fetch/2","type":"function"},{"doc":"Fetch an item from storage.","ref":"Haystack.Storage.html#c:fetch/2","title":"Haystack.Storage.fetch/2","type":"callback"},{"doc":"Fetch an item from storage. Examples iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage . insert ( storage , :name , &quot;Haystack&quot; ) iex&gt; Storage . fetch! ( storage , :name ) &quot;Haystack&quot;","ref":"Haystack.Storage.html#fetch!/2","title":"Haystack.Storage.fetch!/2","type":"function"},{"doc":"Fetch an item from storage.","ref":"Haystack.Storage.html#c:fetch!/2","title":"Haystack.Storage.fetch!/2","type":"callback"},{"doc":"Insert an item into storage Examples iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage . insert ( storage , :name , &quot;Haystack&quot; ) iex&gt; Storage . fetch! ( storage , :name ) &quot;Haystack&quot;","ref":"Haystack.Storage.html#insert/3","title":"Haystack.Storage.insert/3","type":"function"},{"doc":"Insert an item into storage","ref":"Haystack.Storage.html#c:insert/3","title":"Haystack.Storage.insert/3","type":"callback"},{"doc":"Create a new storage.","ref":"Haystack.Storage.html#c:new/1","title":"Haystack.Storage.new/1","type":"callback"},{"doc":"Serialize the storage. Examples iex&gt; storage = Storage.Map . new ( ) iex&gt; Storage . serialize ( storage )","ref":"Haystack.Storage.html#serialize/1","title":"Haystack.Storage.serialize/1","type":"function"},{"doc":"Serialize the storage.","ref":"Haystack.Storage.html#c:serialize/1","title":"Haystack.Storage.serialize/1","type":"callback"},{"doc":"Update an item in storage. Examples iex&gt; storage = Storage.Map . new ( ) iex&gt; Storage . update ( storage , :name , &amp; String . upcase / 1 ) { :error , % Storage.NotFoundError { message : &quot;Not found&quot; } } iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage . insert ( storage , :name , &quot;Haystack&quot; ) iex&gt; { :ok , storage } = Storage . update ( storage , :name , &amp; String . upcase / 1 ) iex&gt; Storage . fetch! ( storage , :name ) &quot;HAYSTACK&quot;","ref":"Haystack.Storage.html#update/3","title":"Haystack.Storage.update/3","type":"function"},{"doc":"Update an item in storage.","ref":"Haystack.Storage.html#c:update/3","title":"Haystack.Storage.update/3","type":"callback"},{"doc":"Update an item in storage. Examples iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage . insert ( storage , :name , &quot;Haystack&quot; ) iex&gt; storage = Storage . update! ( storage , :name , &amp; String . upcase / 1 ) iex&gt; Storage . fetch! ( storage , :name ) &quot;HAYSTACK&quot;","ref":"Haystack.Storage.html#update!/3","title":"Haystack.Storage.update!/3","type":"function"},{"doc":"Update an item in storage.","ref":"Haystack.Storage.html#c:update!/3","title":"Haystack.Storage.update!/3","type":"callback"},{"doc":"Upsert an item in storage. Examples iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage . upsert ( storage , :name , &quot;HAYSTACK&quot; , &amp; String . upcase / 1 ) iex&gt; Storage . fetch! ( storage , :name ) &quot;HAYSTACK&quot; iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage . insert ( storage , :name , &quot;Haystack&quot; ) iex&gt; storage = Storage . upsert ( storage , :name , &quot;HAYSTACK&quot; , &amp; String . upcase / 1 ) iex&gt; Storage . fetch! ( storage , :name ) &quot;HAYSTACK&quot;","ref":"Haystack.Storage.html#upsert/4","title":"Haystack.Storage.upsert/4","type":"function"},{"doc":"Upsert an item in storage.","ref":"Haystack.Storage.html#c:upsert/4","title":"Haystack.Storage.upsert/4","type":"callback"},{"doc":"","ref":"Haystack.Storage.html#t:k/0","title":"Haystack.Storage.k/0","type":"type"},{"doc":"","ref":"Haystack.Storage.html#t:opts/0","title":"Haystack.Storage.opts/0","type":"type"},{"doc":"","ref":"Haystack.Storage.html#t:t/0","title":"Haystack.Storage.t/0","type":"type"},{"doc":"","ref":"Haystack.Storage.html#t:v/0","title":"Haystack.Storage.v/0","type":"type"},{"doc":"An ETS implementation of the storage behaviour.","ref":"Haystack.Storage.ETS.html","title":"Haystack.Storage.ETS","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Haystack.Storage.ETS.html#child_spec/1","title":"Haystack.Storage.ETS.child_spec/1","type":"function"},{"doc":"Return the count of items in storage.","ref":"Haystack.Storage.ETS.html#count/1","title":"Haystack.Storage.ETS.count/1","type":"function"},{"doc":"Delete an item from storage.","ref":"Haystack.Storage.ETS.html#delete/2","title":"Haystack.Storage.ETS.delete/2","type":"function"},{"doc":"Fetch an item from storage.","ref":"Haystack.Storage.ETS.html#fetch/2","title":"Haystack.Storage.ETS.fetch/2","type":"function"},{"doc":"Fetch an item from storage.","ref":"Haystack.Storage.ETS.html#fetch!/2","title":"Haystack.Storage.ETS.fetch!/2","type":"function"},{"doc":"Insert an item into storage.","ref":"Haystack.Storage.ETS.html#insert/3","title":"Haystack.Storage.ETS.insert/3","type":"function"},{"doc":"Create a new storage.","ref":"Haystack.Storage.ETS.html#new/1","title":"Haystack.Storage.ETS.new/1","type":"function"},{"doc":"Serialize the storage.","ref":"Haystack.Storage.ETS.html#serialize/1","title":"Haystack.Storage.ETS.serialize/1","type":"function"},{"doc":"","ref":"Haystack.Storage.ETS.html#start_link/1","title":"Haystack.Storage.ETS.start_link/1","type":"function"},{"doc":"Update an item in storage.","ref":"Haystack.Storage.ETS.html#update/3","title":"Haystack.Storage.ETS.update/3","type":"function"},{"doc":"Update an item in storage.","ref":"Haystack.Storage.ETS.html#update!/3","title":"Haystack.Storage.ETS.update!/3","type":"function"},{"doc":"Upsert an item in storage.","ref":"Haystack.Storage.ETS.html#upsert/4","title":"Haystack.Storage.ETS.upsert/4","type":"function"},{"doc":"","ref":"Haystack.Storage.ETS.html#t:t/0","title":"Haystack.Storage.ETS.t/0","type":"type"},{"doc":"A map implementation of the storage behaviour.","ref":"Haystack.Storage.Map.html","title":"Haystack.Storage.Map","type":"module"},{"doc":"Return the count of items in storage. Examples iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage . insert ( storage , :name , &quot;Haystack&quot; ) iex&gt; Storage . count ( storage ) 1","ref":"Haystack.Storage.Map.html#count/1","title":"Haystack.Storage.Map.count/1","type":"function"},{"doc":"Delete an item from storage. Examples iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage.Map . delete ( storage , :name ) iex&gt; Storage.Map . fetch ( storage , :name ) { :error , % Storage.NotFoundError { message : &quot;Not found&quot; } } iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage.Map . insert ( storage , :name , &quot;Haystack&quot; ) iex&gt; storage = Storage.Map . delete ( storage , :name ) iex&gt; Storage.Map . fetch ( storage , :name ) { :error , % Storage.NotFoundError { message : &quot;Not found&quot; } }","ref":"Haystack.Storage.Map.html#delete/2","title":"Haystack.Storage.Map.delete/2","type":"function"},{"doc":"Fetch an item from storage. Examples iex&gt; storage = Storage.Map . new ( ) iex&gt; Storage.Map . fetch ( storage , :name ) { :error , % Storage.NotFoundError { message : &quot;Not found&quot; } } iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage.Map . insert ( storage , :name , &quot;Haystack&quot; ) iex&gt; Storage.Map . fetch ( storage , :name ) { :ok , &quot;Haystack&quot; }","ref":"Haystack.Storage.Map.html#fetch/2","title":"Haystack.Storage.Map.fetch/2","type":"function"},{"doc":"Fetch an item from storage. Examples iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage.Map . insert ( storage , :name , &quot;Haystack&quot; ) iex&gt; Storage.Map . fetch! ( storage , :name ) &quot;Haystack&quot;","ref":"Haystack.Storage.Map.html#fetch!/2","title":"Haystack.Storage.Map.fetch!/2","type":"function"},{"doc":"Insert an item into storage. Examples iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage.Map . insert ( storage , :name , &quot;Haystack&quot; ) iex&gt; Storage.Map . fetch! ( storage , :name ) &quot;Haystack&quot;","ref":"Haystack.Storage.Map.html#insert/3","title":"Haystack.Storage.Map.insert/3","type":"function"},{"doc":"Create a new storage. Examples iex&gt; Storage.Map . new ( )","ref":"Haystack.Storage.Map.html#new/1","title":"Haystack.Storage.Map.new/1","type":"function"},{"doc":"Serialize the storage. Examples iex&gt; storage = Storage.Map . new ( ) iex&gt; Storage . serialize ( storage )","ref":"Haystack.Storage.Map.html#serialize/1","title":"Haystack.Storage.Map.serialize/1","type":"function"},{"doc":"Update an item in storage. Examples iex&gt; storage = Storage.Map . new ( ) iex&gt; Storage.Map . update ( storage , :name , &amp; String . upcase / 1 ) { :error , % Storage.NotFoundError { message : &quot;Not found&quot; } } iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage.Map . insert ( storage , :name , &quot;Haystack&quot; ) iex&gt; { :ok , storage } = Storage.Map . update ( storage , :name , &amp; String . upcase / 1 ) iex&gt; Storage.Map . fetch! ( storage , :name ) &quot;HAYSTACK&quot;","ref":"Haystack.Storage.Map.html#update/3","title":"Haystack.Storage.Map.update/3","type":"function"},{"doc":"Update an item in storage. Examples iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage.Map . insert ( storage , :name , &quot;Haystack&quot; ) iex&gt; storage = Storage.Map . update! ( storage , :name , &amp; String . upcase / 1 ) iex&gt; Storage.Map . fetch! ( storage , :name ) &quot;HAYSTACK&quot;","ref":"Haystack.Storage.Map.html#update!/3","title":"Haystack.Storage.Map.update!/3","type":"function"},{"doc":"Upsert an item in storage. Examples iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage.Map . upsert ( storage , :name , &quot;HAYSTACK&quot; , &amp; String . upcase / 1 ) iex&gt; Storage.Map . fetch! ( storage , :name ) &quot;HAYSTACK&quot; iex&gt; storage = Storage.Map . new ( ) iex&gt; storage = Storage.Map . insert ( storage , :name , &quot;Haystack&quot; ) iex&gt; storage = Storage.Map . upsert ( storage , :name , &quot;HAYSTACK&quot; , &amp; String . upcase / 1 ) iex&gt; Storage.Map . fetch! ( storage , :name ) &quot;HAYSTACK&quot;","ref":"Haystack.Storage.Map.html#upsert/4","title":"Haystack.Storage.Map.upsert/4","type":"function"},{"doc":"","ref":"Haystack.Storage.Map.html#t:t/0","title":"Haystack.Storage.Map.t/0","type":"type"},{"doc":"A module for tokenizing values. This module provides utilities for tokenizing values. The default tokenizer removes anything but alphanumeric characters and extracts the positions of words using a start offset and length. There's also a :full tokenizer that can be used when the full value should be treated as a single token. For example, a serial code.","ref":"Haystack.Tokenizer.html","title":"Haystack.Tokenizer","type":"module"},{"doc":"Return the seperator Examples iex&gt; Tokenizer . separator ( :default ) ~r/([[:alnum:]]+)/ iex&gt; Tokenizer . separator ( :full ) ~r/(.+)/","ref":"Haystack.Tokenizer.html#separator/1","title":"Haystack.Tokenizer.separator/1","type":"function"},{"doc":"Tokenize a value. Examples iex&gt; tokens = Tokenizer . tokenize ( &quot;Needle in a Haystack&quot; ) iex&gt; Enum . map ( tokens , &amp; &amp;1 . v ) ~w{needle in a haystack}","ref":"Haystack.Tokenizer.html#tokenize/1","title":"Haystack.Tokenizer.tokenize/1","type":"function"},{"doc":"Tokenize a value with a given separator. Examples iex&gt; tokens = Tokenizer . tokenize ( &quot;Needle in a Haystack&quot; , Tokenizer . separator ( :default ) ) iex&gt; Enum . map ( tokens , &amp; &amp;1 . v ) ~w{needle in a haystack}","ref":"Haystack.Tokenizer.html#tokenize/2","title":"Haystack.Tokenizer.tokenize/2","type":"function"},{"doc":"A module for Tokens.","ref":"Haystack.Tokenizer.Token.html","title":"Haystack.Tokenizer.Token","type":"module"},{"doc":"Create a new token. Examples iex&gt; Token . new ( &quot;abc&quot; , offset : 0 , length : 3 )","ref":"Haystack.Tokenizer.Token.html#new/2","title":"Haystack.Tokenizer.Token.new/2","type":"function"},{"doc":"","ref":"Haystack.Tokenizer.Token.html#t:opts/0","title":"Haystack.Tokenizer.Token.opts/0","type":"type"},{"doc":"","ref":"Haystack.Tokenizer.Token.html#t:t/0","title":"Haystack.Tokenizer.Token.t/0","type":"type"},{"doc":"","ref":"Haystack.Tokenizer.Token.html#t:v/0","title":"Haystack.Tokenizer.Token.v/0","type":"type"},{"doc":"A module for transforming tokens. This module includes a transform/1 callback behaviour for implementing stages of a transformation pipeline. The default pipeline transformers includes stages for stemming and removing stop words.","ref":"Haystack.Transformer.html","title":"Haystack.Transformer","type":"behaviour"},{"doc":"Return the list of default transformers. Examples iex&gt; Transformer . default ( ) [ Transformer.Stemmer , Transformer.StopWords ]","ref":"Haystack.Transformer.html#default/0","title":"Haystack.Transformer.default/0","type":"function"},{"doc":"Apply a pipeline of transformers to a list of tokens. Examples iex&gt; tokens = Tokenizer . tokenize ( &quot;Needle in a Haystack&quot; ) iex&gt; tokens = Transformer . pipeline ( tokens , Transformer . default ( ) ) iex&gt; Enum . map ( tokens , &amp; &amp;1 . v ) ~w{needl haystack}","ref":"Haystack.Transformer.html#pipeline/2","title":"Haystack.Transformer.pipeline/2","type":"function"},{"doc":"Apply a transformation on a list of tokens.","ref":"Haystack.Transformer.html#c:transform/1","title":"Haystack.Transformer.transform/1","type":"callback"},{"doc":"A transformer for stemming words.","ref":"Haystack.Transformer.Stemmer.html","title":"Haystack.Transformer.Stemmer","type":"module"},{"doc":"Apply a stemming transformation on a list of tokens. Examples iex&gt; tokens = Tokenizer . tokenize ( &quot;Needle in a Haystack&quot; ) iex&gt; tokens = Transformer.Stemmer . transform ( tokens ) iex&gt; Enum . map ( tokens , &amp; &amp;1 . v ) ~w{needl in a haystack}","ref":"Haystack.Transformer.Stemmer.html#transform/1","title":"Haystack.Transformer.Stemmer.transform/1","type":"function"},{"doc":"A transformer for removing stop words.","ref":"Haystack.Transformer.StopWords.html","title":"Haystack.Transformer.StopWords","type":"module"},{"doc":"Remove stop words from a list of tokens. Examples iex&gt; tokens = Tokenizer . tokenize ( &quot;Needle in a Haystack&quot; ) iex&gt; tokens = Transformer.StopWords . transform ( tokens ) iex&gt; Enum . map ( tokens , &amp; &amp;1 . v ) ~w{needle haystack}","ref":"Haystack.Transformer.StopWords.html#transform/1","title":"Haystack.Transformer.StopWords.transform/1","type":"function"},{"doc":"Not found error.","ref":"Haystack.Storage.NotFoundError.html","title":"Haystack.Storage.NotFoundError","type":"exception"},{"doc":"","ref":"Haystack.Storage.NotFoundError.html#t:t/0","title":"Haystack.Storage.NotFoundError.t/0","type":"type"}]